﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Drawing.Drawing2D;

namespace howto_moving_gradient
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private float GradientStart = 0;
        private float Delta = 5f;

        // Make the PictureBox redraw.
        private void tmrRefresh_Tick(object sender, EventArgs e)
        {
            picCanvas.Refresh();
        }

        // Draw the background with text on top.
        private void picCanvas_Paint(object sender, PaintEventArgs e)
        {
            // Shade the background.
            int wid = picCanvas.ClientSize.Width;
            ShadeRect(e.Graphics, GradientStart, GradientStart + wid);

            // Increase the start position.
            GradientStart += Delta;
            if (GradientStart >= wid) GradientStart = 0;

            // Draw some text.
            using (Font font = new Font("Times New Roman", 16, FontStyle.Bold))
            {
                using (StringFormat string_format = new StringFormat())
                {
                    string_format.Alignment = StringAlignment.Center;
                    string_format.LineAlignment = StringAlignment.Center;
                    e.Graphics.DrawString("Moving Gradient",
                        font, Brushes.Black,
                        picCanvas.ClientSize.Width / 2,
                        picCanvas.ClientSize.Height / 2,
                        string_format);
                }
            }
        }

        // Fill the rectangle with a gradient that
        // shades from red to white to red.
        private void ShadeRect(Graphics gr, float xmin, float xmax)
        {
            using (LinearGradientBrush br = new LinearGradientBrush(
                new PointF(xmin, 0), new PointF(xmax, 0),
                Color.Red, Color.Red))
            {
                br.WrapMode = WrapMode.Tile;
                ColorBlend color_blend = new ColorBlend();
                color_blend.Colors = new Color[] { Color.Red, Color.White, Color.Red };
                color_blend.Positions = new float[] { 0, 0.5f, 1 };

                br.InterpolationColors = color_blend;
                gr.FillRectangle(br, picCanvas.ClientRectangle);
            }
        }
    }
}
